Subject: bug#62379: closed (Re: bug#62379: /gnu/store/.links filling the hard drive on foreign distro)

From: [email-masked] (GNU bug Tracking System)
Date: Sun, 07 May 2023 15:06:02 +0000

Your bug report

#62379: /gnu/store/.links filling the hard drive on foreign distro

which was filed against the guix package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
62379: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=62379
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#62379: /gnu/store/.links filling the hard drive on foreign distro
From: Maxim Cournoyer <[email-masked]>
To: Ludovic Courtès <[email-masked]>
Cc: [email-masked], Elias Kueny <[email-masked]>
Date: Sun, 07 May 2023 11:05:21 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

Ludovic Courtès <[email-masked]> writes:

> Hi,
>
> Elias Kueny <[email-masked]> skribis:
>
>> The problem is the size of /gnu/store/.links: after garbage collection
>> with "guix gc --delete-generations=1w", /gnu/store is 17.4 GB in
>> total, and /gnu/store/.links is 14.5 GB (344120 items, ranging from 93
>> MB to 4.1 kB each).
>
> This is expected: /gnu/store/.links contains hard links to other files
> in /gnu/store.  IOW /gnu/store/.links is a subset of the rest of
> /gnu/store, sharing the same inodes.
>
>> The garbage collector prints that "currently hard linking saves
>> 3717.77 MiB".  With a 40GB hard drive, the gnu store regularly fills
>> up all the available space if I'm not careful. I found from an old
>> issue (https://issues.guix.gnu.org/24937#1) that 10 millions links
>> should need around 700 MB, so this sounds like a bug.
>
> Note that the issue you mention was addressed to a large extent in 2021:
>
>   https://issues.guix.gnu.org/24937#20
>

Closing, as this is working as intended.  If you do not wish to use the
guix-daemon deduplication feature, you can provide it with the
'--disable-deduplication', with the caveat that your hard drive may be
filled even faster :-).

-- 
Thanks,
Maxim

Subject: /gnu/store/.links filling the hard drive on foreign distro
From: Elias Kueny <[email-masked]>
To: [email-masked]
Date: Wed, 22 Mar 2023 10:48:04 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,

I'm using guix over a foreign distro (Ubuntu 22.04). I initially installed guix from the Ubuntu repositories (version 1.3.0-4), and updated as user with guix pull (work computer: I don't have root access to run the installer script).

The problem is the size of /gnu/store/.links: after garbage collection with "guix gc --delete-generations=1w", /gnu/store is 17.4 GB in total, and /gnu/store/.links is 14.5 GB (344120 items, ranging from 93 MB to 4.1 kB each). The garbage collector prints that "currently hard linking saves 3717.77 MiB".
With a 40GB hard drive, the gnu store regularly fills up all the available space if I'm not careful. I found from an old issue (https://issues.guix.gnu.org/24937#1) that 10 millions links should need around 700 MB, so this sounds like a bug.

After garbage collection, there are only 16 profiles left in /var/guix/profiles/per-user/ for my account: 2 for current-guix, 2 for guix-profile, and the rest for guix-home (where almost every program is installed), plus one guix shell profile I keep activated during gc to not uninstall it. I can't check for the root account, but I'm guessing it contains only the profile of the initial guix installation. There are no other users.

I tried uninstalling the original guix from the Ubuntu repositories in case the issue is due to some interference between it and the current guix I pulled as user, but /var/guix/daemon-socket/socket was gone with it, so I couldn't try to run the garbage collection.

Elias